PRO PRINT_INSTRUMENT, instr, latex=latex

  ON_ERROR, 2

  nchannels = instr.nchannel
  tags = ['channel','FWHM','YSZ2KCMB','KRJ2KCMB','MJYSR2KCMB']
  
  ntags = N_ELEMENTS(tags)
  
  tab = STRARR(ntags,nchannels+2)
  leng = 16

  tab[*,0] = PSM_STRING_TO_LENGTH(tags, leng, /leading, character=' ')
  tab[*,1] = PSM_STRING_TO_LENGTH('  ', leng, character='-')
  FOR i=2, nchannels+1 DO BEGIN
     tab[0,i] = PSM_STRING_TO_LENGTH(CHANNELPARAM(instr,'name',i-1),leng,/leading,character=' ')
     IF CHANNELPARAM(instr,'beam.type',i-1) EQ 'GAUSSIAN' THEN BEGIN
        tab[1,i] = PSM_STRING_TO_LENGTH(NUMBER2STRING(CHANNELPARAM(instr,'beam.size',i-1)),leng,/leading,character=' ')
     ENDIF ELSE BEGIN
        tab[1,i] = PSM_STRING_TO_LENGTH('N/A',leng,/leading,character=' ')
     ENDELSE
     tab[2,i] = PSM_STRING_TO_LENGTH(STRING(CHANNELPARAM(instr,'conversion.ysz2units',i-1)/CHANNELPARAM(instr,'conversion.kcmb2units',i-1)),leng,/leading,character=' ')
     tab[3,i] = PSM_STRING_TO_LENGTH(STRING(CHANNELPARAM(instr,'conversion.krj2units',i-1)/CHANNELPARAM(instr,'conversion.kcmb2units',i-1)),leng,/leading,character=' ')
     tab[4,i] = PSM_STRING_TO_LENGTH(STRING(CHANNELPARAM(instr,'conversion.megajysr2units',i-1)/CHANNELPARAM(instr,'conversion.kcmb2units',i-1)),leng,/leading,character=' ')
  ENDFOR

  IF KEYWORD_SET(latex) THEN BEGIN
     nline = N_ELEMENTS(tab[0,*])-1
     ncol =  N_ELEMENTS(tab[*,0])
     latextable = STRARR(nline)
     i=0
     FOR j=0, ncol-2 DO BEGIN
        latextable[i] = latextable[i] + STRTRIM(tab[j,i]) + ' & ' 
     ENDFOR
     latextable[i] = latextable[i] + STRTRIM(tab[j,i]) + ' \\'
     FOR i=1, nline-1 DO BEGIN
        FOR j=0, ncol-2 DO BEGIN
           latextable[i] = latextable[i] + STRTRIM(tab[j,i+1]) + ' & ' 
        ENDFOR
        latextable[i] = latextable[i] + STRTRIM(tab[j,i+1]) + ' \\'
     ENDFOR
     FOR i=0, N_ELEMENTS(latextable)-1 DO latextable[i] = PSM_STR_REPLACE(latextable[i],'_','\_')
     PRINT, latextable
  ENDIF ELSE BEGIN
     PRINT, tab
  ENDELSE

END
