PRO INDEX_BANDS, instr, index, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'INDEX_BANDS: procedure for indexing all bands in an instrument (same bands get same index)'
     PSM_INFO_MESSAGE, 'SYNTAX: INDEX_BANDS, instr, index'
     PSM_INFO_MESSAGE, 'instr is an instrument structure, created with LOAD_INSTRUMENT or ALL_INSTRUMENTS'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
  ENDIF

  nb = instr.nchannel

  IF nb GE 1 THEN BEGIN

     index = [0]
     currentindex = 0

     IF nb GE 2 THEN BEGIN
        FOR i=1,nb-1 DO BEGIN
           j=0
           nexti = 0B
           WHILE NOT nexti DO BEGIN 
              test = STRUCT_EQUAL(CHANNELPARAM(instr,'band',i+1),CHANNELPARAM(instr,'band',j+1)) AND (CHANNELPARAM(instr,'INST',i+1) EQ CHANNELPARAM(instr,'INST',j+1))
              IF test THEN BEGIN
                 index = [index,index[j]]
                 nexti = 1B
              ENDIF ELSE BEGIN
                 j = j+1
                 IF j EQ i THEN BEGIN
                    nexti = 1B
                    index = [index, currentindex+1]
                    currentindex = currentindex + 1
                 ENDIF
              ENDELSE
           ENDWHILE
        ENDFOR
     ENDIF

  ENDIF


END
