PRO INDEX_STOKES, instr, index, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'INDEX_STOKES: procedure for indexing all stokes params in an instrument (same stokes params get same index)'
     PSM_INFO_MESSAGE, 'SYNTAX: INDEX_STOKES, instr, index'
     PSM_INFO_MESSAGE, 'instr is an instrument structure, created with LOAD_INSTRUMENT or ALL_INSTRUMENTS'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
  ENDIF


  nb = instr.nchannel

  IF nb GE 1 THEN BEGIN

     index = INTARR(nb)

     ;; Get list of stokes types (e.g. T, TQU...)
     ;;-------------------------------------------
     list_types = [instr.channel_1.stokes]
     IF nb GE 2 THEN FOR i=2,nb DO list_types = [list_types, CHANNELPARAM(instr,'stokes',i)]
  
     ;; Get list of all stokes types
     ;;------------------------------
     shortlist = PSM_UNIQ(list_types,index=ilist)
     ntypes = N_ELEMENTS(shortlist)
     
     ;; For each stokes type, compare whether the structures describing the stokes parameters are equal
     ;;-------------------------------------------------------------------------------------------------
     a=0
     FOR t=0, ntypes-1 DO BEGIN

        ;; Make an array containing all stokes parameters of that type
        wh = WHERE(ilist EQ t, nwh)
        list = [CHANNELPARAM(instr,'stokes',wh[0]+1)]
        IF nwh GE 2 THEN FOR j=1,nwh-1 DO list = [list,CHANNELPARAM(instr,'stokes',wh[j]+1)]
        ;; Find whether some stokes parameters are the same, update the index
        uni = PSM_UNIQ(list,index=bins)
        index[wh] = [a+bins]
        a = a+N_ELEMENTS(uni)

     ENDFOR
  ENDIF
  
END
