PRO INDEX_UNITS, instr, index, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'INDEX_UNITS: procedure for indexing all observation units used in an instrument (same units get same index)'
     PSM_INFO_MESSAGE, 'SYNTAX: INDEX_UNITS, instr, index'
     PSM_INFO_MESSAGE, 'instr is an instrument structure, created with LOAD_INSTRUMENT or ALL_INSTRUMENTS'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
  ENDIF


  nb = instr.nchannel

  IF nb GE 1 THEN BEGIN

     index = INTARR(nb)

     ;; Get list of obs_units (e.g. mK_CMB, MJy/sr...)
     ;;------------------------------------------------
     list_units = [instr.channel_1.obs_units]
     IF nb GE 2 THEN FOR i=2,nb DO list_units = [list_units, CHANNELPARAM(instr,'obs_units',i)]
  
     ;; Get list of all represented units
     ;;-----------------------------------
     shortlist = PSM_UNIQ(list_units,index=ilist)
     ntypes = N_ELEMENTS(shortlist)
     
     ;; For each represented unit, compare whether the obs_units of each channel is that one
     ;;--------------------------------------------------------------------------------------
     a=0
     FOR t=0, ntypes-1 DO BEGIN

        ;; Make an array containing all units of that type
        wh = WHERE(ilist EQ t, nwh)
        list = [CHANNELPARAM(instr,'obs_units',wh[0]+1)]
        IF nwh GE 2 THEN FOR j=1,nwh-1 DO list = [list,CHANNELPARAM(instr,'obs_units',wh[j]+1)]
        ;; Find whether some units are the same, update the index
        uni = PSM_UNIQ(list,index=bins)
        index[wh] = [a+bins]
        a = a+N_ELEMENTS(uni)

     ENDFOR
  ENDIF
  
END
