PRO ELLIPTIC_GAUSSIAN_BEAM_ON_SKY, fwhm_max, fwhm_min, theta_rad, phi_rad, el_theta, listpix, shape, nside=nside, polar=polar, help=help

  pixsize = NSIDE2PIXSIZE(nside, /arcmin)



  fwhm_rad_max = fwhm_max * 2.9088821e-4    ; 2.9088821e-4 : conversion from arcmin to radians
  fwhm_rad_min = fwhm_min * 2.9088821e-4

  

  ANG2VEC, theta_rad, phi_rad, pos ; pos = Array[npts, 3]
  
  npts = N_ELEMENTS(pos) / 3L
  listpix = PTRARR(npts,/allocate_heap)
  shape = PTRARR(npts,/allocate_heap)
  omegapix = 1.0471976 / FLOAT(nside)^2 ; 1.0471976 = 4pi/12
  
  FOR i=0L, npts-1 DO BEGIN
     IF fwhm_max[i] LE pixsize THEN BEGIN
        VEC2PIX_RING, nside, pos[i,*], lis
        *(listpix[i]) = lis
        nlis = 1
        dis = 1./omegapix
        IF NOT KEYWORD_SET(polar) THEN BEGIN
           *(shape[i]) = {amplitude:dis}
        ENDIF ELSE BEGIN
           *(shape[i]) = {amplitude:dis,rotation:0.}
        ENDELSE
     ENDIF ELSE BEGIN

        rmax = 3.5*fwhm_rad_max[i]
        asur2 = 2.7725887 / fwhm_rad_min[i]^2 ; 2.7725887 = (8d*alog(2)) / 2
        angle = el_theta[i]
        maj_on_min = fwhm_rad_max[i]*1./fwhm_rad_min[i]

        query_disc , nside, pos[i,*], rmax, lis, /INCLUSIVE
        *(listpix[i]) = lis

        pix2vec_ring, nside, lis, vector ;help, vector = Array[npix, 3]
              
        oldvector=vector
              
        if keyword_set(nest) then begin
           ang2pix_nest, nside, 0,0, north_pix
           pix2vec_nest, nside, north_pix, north_vec
        endif else begin
           ang2pix_ring, nside, 0,0, north_pix
           pix2vec_ring, nside, north_pix, north_vec
        endelse
        if (total(crossp(north_vec,pos[i,*])) ne 0) then begin
           vec_axe_b=crossp(north_vec,pos[i,*])
        endif else begin
           ang2vec, !dpi/2., 0, ref_vec
           vec_axe_b=crossp(north_vec,ref_vec)
        endelse
        vec_axe_a=crossp(pos[i,*],vec_axe_b)
        
        temp_vector=fltarr(3)
        
        vector_rotation, vec_axe_b, transpose(pos[i,*]), angle, temp_vector
        vec_axe_b=temp_vector
        vector_rotation, vec_axe_a, transpose(pos[i,*]), angle, temp_vector
        vec_axe_a=temp_vector
        
        
        dis=dblarr(n_elements(lis))
        for j=0L,n_elements(lis)-1 do begin
           temp_vector[*]=vector[j,*]
           vector_get_angle, temp_vector, vec_axe_a, temp_angle
           ang_plane=!dpi/2.-temp_angle
           
           if (transpose(vec_axe_a)#temp_vector ge 0) then begin
              vector_rotation, temp_vector, vec_axe_b, ang_plane*(1-1./maj_on_min), new_vector
           endif else begin
              vector_rotation, temp_vector, vec_axe_b, ang_plane*(1-1./maj_on_min), new_vector
           endelse
           
           vector[j,*]=new_vector   
                
           vector_get_angle,new_vector, transpose(pos[i,*]), dist_angle
           dis[j] = dist_angle
        endfor               
        dis = EXP(-dis^2*asur2)
        dis = dis / (omegapix*TOTAL(dis))
if finite(dis[0]) eq 0 then stop
        IF NOT KEYWORD_SET(polar) THEN BEGIN
           *(shape[i]) = {amplitude:dis}
        ENDIF ELSE BEGIN
           PIX2VEC_RING, nside, lis, vec
           VEC2ANG, vec, theta_p, phi_p
           POLAR_NEARBY_ANGLE_ON_SPHERE, theta_rad[i], phi_rad[i], 0, theta_p, phi_p, angle
           *(shape[i]) = {amplitude:dis,rotation:angle}
        ENDELSE
     ENDELSE
  ENDFOR
  

END
