PRO GAUSSIAN_BEAM_ON_SKY, fwhm, theta_rad, phi_rad, listpix, shape, nside=nside, polar=polar, help=help

  pixsize = NSIDE2PIXSIZE(nside, /arcmin)

  IF fwhm LE pixsize THEN BEGIN
  ENDIF


  fwhm_rad = fwhm * 2.9088821e-4    ; 2.9088821e-4 : conversion from arcmin to radians
  asur2 = 2.7725887 / fwhm_rad^2    ; 2.7725887 = (8d*alog(2)) / 2
  
  rmax = 3.5*fwhm_rad
  ANG2VEC, theta_rad, phi_rad, pos ; pos = Array[npts, 3]
  
  npts = N_ELEMENTS(pos) / 3L
  listpix = PTRARR(npts,/allocate_heap)
  shape = PTRARR(npts,/allocate_heap)
  omegapix = 1.0471976 / FLOAT(nside)^2 ; 1.0471976 = 4pi/12
  
  FOR i=0L, npts-1 DO BEGIN
     IF fwhm LE pixsize THEN BEGIN
        VEC2PIX_RING, nside, pos[i,*], lis
        *(listpix[i]) = lis
        nlis = 1
        dis = 1./omegapix
        IF NOT KEYWORD_SET(polar) THEN BEGIN
           *(shape[i]) = {amplitude:dis}
        ENDIF ELSE BEGIN
           *(shape[i]) = {amplitude:dis,rotation:0.}
        ENDELSE
     ENDIF ELSE BEGIN
        QUERY_DIST, nside, pos[i,*], rmax, lis, nlis, dis, /INCLUSIVE
        *(listpix[i]) = lis
        dis = EXP(-dis^2*asur2)
        dis = dis / (omegapix*TOTAL(dis))
        IF NOT KEYWORD_SET(polar) THEN BEGIN
           *(shape[i]) = {amplitude:dis}
        ENDIF ELSE BEGIN
           PIX2VEC_RING, nside, lis, vec
           VEC2ANG, vec, theta_p, phi_p
           POLAR_NEARBY_ANGLE_ON_SPHERE, theta_rad[i], phi_rad[i], 0, theta_p, phi_p, angle
           *(shape[i]) = {amplitude:dis,rotation:angle}
        ENDELSE
     ENDELSE
  ENDFOR
  

END
