FUNCTION GET_PIX_STRUCT, pixtype, $
                         ;; Healpix
                         hpx_nside=hpx_nside, hpx_ordering=hpx_ordering, hpx_coordsys=hpx_coordsys


  CASE pixtype OF 
     
     ;; Healpix
     ;;---------
     'HEALPIX': BEGIN

        ;; nside and npix
        ;;----------------
        IF NOT DEFINED(hpx_nside) THEN BEGIN
           hpx_nside=1L
           hpx_npix=12L
        ENDIF ELSE BEGIN
           hpx_npix = 12L * LONG(hpx_nside)^2
        ENDELSE
           
        ;; ordering
        ;;----------
        IF NOT DEFINED(hpx_ordering) THEN hpx_ordering='RING'

        ;; object type
        ;;-------------
        IF NOT DEFINED(hpx_object) THEN hpx_object='FULLSKY'

        ;; first and last pixels
        ;;-----------------------
        IF NOT DEFINED(hpx_firstpix) THEN hpx_firstpix = 0L
        IF NOT DEFINED(hpx_lastpix) THEN hpx_lastpix = hpx_npix-1L

        ;; indexing scheme
        ;;-----------------
        IF NOT DEFINED(hpx_indxschm) THEN hpx_indxschm = 'IMPLICIT'

        ;; coordinate system
        ;;-------------------
        IF NOT DEFINED(hpx_coordsys) THEN hpx_coordsys = 'G'

        pix = { $
              pixtype: 'HEALPIX', $
              nside: LONG(hpx_nside), $
              npix: LONG(hpx_npix), $
              ordering: hpx_ordering, $
              object: hpx_object, $
              firstpix: hpx_firstpix, $
              lastpix: hpx_lastpix, $
              indxschm: hpx_indxschm, $
              coordsys: hpx_coordsys $ 
              }
     END
     
     ;; SKYPIX = Sky pixelisation, obtained with SKY_PIX.PRO
     ;;------------------------------------------------------
     'SKYPIX': pix = SKY_PIX()

     ELSE: BEGIN
        pix = {pixtype: 'UNKNOWN'}
        PSM_INFO_MESSAGE, 'Pixelisation type not implemented'
     END
  ENDCASE
  
  RETURN, pix
  
END
