FUNCTION DETECTOR_COVERAGE, ringpointing, detector, instrument=instrument, version=version, coordsys=coordsys, nside=nside, nosmooth=nosmooth

  char3 = FIRSTCHAR(detector,3)
  CASE char3 OF
     'LFI': BEGIN
        IF KEYWORD_SET(instrument) NE 0 THEN BEGIN
           IF FIRSTCHAR(instrument,3) NE 'LFI' THEN STOP
        ENDIF
        d = RIMO_CHANNELPARAM('LFI',version=version)
     END
     ELSE: BEGIN
        IF KEYWORD_SET(instrument) NE 0 THEN BEGIN
           IF FIRSTCHAR(instrument,3) NE 'HFI' THEN STOP
        ENDIF
        d = RIMO_CHANNELPARAM('HFI',version=version)        
     END
  ENDCASE

  wh = WHERE(d.detector EQ detector, nwh)
  IF nwh NE 1 THEN MESSAGE, 'Detector info not available' ELSE BEGIN
     theta_uv = (d.theta_uv)[wh[0]]
     phi_uv = (d.phi_uv)[wh[0]]
     beam = (d.fwhm)[wh[0]]
  ENDELSE
  
  d_openangle = -theta_uv*sin(phi_uv*!dtor)
  dtheta_rad = d_openangle*!dtor
  mapcover =  RING_COVERAGE(ringpointing, dtheta_rad, coordsys=coordsys, nside=nside)

  IF NOT KEYWORD_SET(nosmooth) THEN BEGIN
     tot = TOTAL(mapcover)
     CHANGE_MAP_RESOLUTION, TEMPORARY(mapcover), mapcover, beam_in=0, beam_out=beam, /nohdr
     newtot = TOTAL(mapcover)
     mapcover = TEMPORARY(mapcover) * tot/newtot
  ENDIF

  RETURN, mapcover

END
