FUNCTION HEADER_LMAX, hd, ok=ok, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, ''
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'HEADER_LMAX: function to get the maximum multipole stored in the header of a map or alm fits file'
     PSM_INFO_MESSAGE, 'SYNTAX: result = FITSFILE_LMAX(hd)'
     PSM_INFO_MESSAGE, 'The status is returned in the OK output keyword.'
     PSM_INFO_MESSAGE, 'If lmax was found, then OK=1B, otherwise OK=0B.'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  ok=1B

  lmax = SXPAR(hd, 'PSM_LMAX', count=countlmax, /silent)
  maxlpol = SXPAR(hd, 'MAX-LPOL', count=countmaxlpol, /silent)
  nlmax = SXPAR(hd, 'NLMAX', count=countnlmax, /silent)

  IF countlmax GE 1 THEN BEGIN
     IF countmaxlpol GE 1 THEN IF lmax NE maxlpol THEN BEGIN
        IF PSM_CAREFULNESS() GE 1 THEN MESSAGE, 'Ambiguous lmax in header'
     ENDIF
     IF countnlmax GE 1 THEN IF lmax NE nlmax THEN BEGIN
        IF PSM_CAREFULNESS() GE 1 THEN MESSAGE, 'Ambiguous lmax in header'
     ENDIF
  ENDIF
  IF countmaxlpol GE 1 THEN BEGIN
     IF countnlmax GE 1 THEN IF maxlpol NE nlmax THEN BEGIN
        IF PSM_CAREFULNESS() GE 1 THEN MESSAGE, 'Ambiguous lmax in header'
     ENDIF
  ENDIF

  IF countlmax EQ 1 THEN RETURN, LONG(lmax)
  IF PSM_CAREFULNESS() EQ 0 THEN BEGIN
     IF countmaxlpol EQ 1 THEN RETURN, LONG(maxlpol) 
     IF countnlmax EQ 1 THEN RETURN, LONG(nlmax)
  ENDIF

  ok=0B

  IF PSM_CAREFULNESS() GE 2 THEN MESSAGE, 'lmax information unavailable in header' $
  ELSE RETURN, -1


END
