FUNCTION PSM_COMP_HDR, compname=compname, compid=compid, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'PSM_COMP_HDR: function to generate PSM component header information array'
     PSM_INFO_MESSAGE, 'SYNTAX: result = PSM_COMP_HDR(compname=, compid=)'
     PSM_INFO_MESSAGE, "compname is the name of the component (e.g. 'cmb')"
     PSM_INFO_MESSAGE, "compid is the 16 ASCII character ID key of the component"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  ;hd = ['COMMENT  --- component header ---']
  ;hd = PSM_STRING_TO_LENGTH(hd,80,character='-')
  hd = [PSMHDRBLOCK_HEADLINE('comp')]

  IF DEFINED(compname) THEN SXADDPAR, hd, 'PSM_CPNM', compname, "PSM component name ('cmb', 'synchrotron', ...)" ELSE $
     SXADDPAR, hd, 'PSM_CPNM', '', "PSM component name ('cmb', 'synchrotron', ...)"
  IF DEFINED(compid) THEN SXADDPAR, hd, 'PSM_CPID', compid, "PSM component ID key" ELSE $
     SXADDPAR, hd, 'PSM_CPID', '', "PSM component ID key"
  hd = hd[0:N_ELEMENTS(hd)-2]

RETURN, hd
END
