FUNCTION COUNT_LINES_OF_CODE, filename, nocomment=nocomment, code=code
   OPENR, unit, filename, /GET_LUN  
   str = ''  
   comment_char = ';'
   IF KEYWORD_SET(code) NE 0 THEN BEGIN
      CASE code OF
         'f90': comment_char='!'
         'c': BEGIN
            comment_start = '/*'
            comment_end = '*/'
         END
      ENDCASE
      ENDIF ELSE code='idl'
   count = 0ll  

   iscomment = 0
   WHILE ~ EOF(unit) DO BEGIN  
      READF, unit, str  
      str = STRTRIM(str,2)
      IF STRLEN(str) NE 0 THEN BEGIN 
         IF KEYWORD_SET(nocomment) NE 0 THEN BEGIN
            CASE code OF
               'c': BEGIN
                  IF iscomment THEN BEGIN
                     IF LASTCHAR(str,2) EQ comment_end THEN iscomment=0
                  ENDIF ELSE BEGIN
                     IF NOT iscomment THEN BEGIN
                        IF FIRSTCHAR(str,2) NE comment_start THEN count = count + 1 ELSE iscomment=1
                     ENDIF
                  ENDELSE
               END
               ELSE: IF FIRSTCHAR(str) NE comment_char THEN count = count + 1
            ENDCASE
         ENDIF ELSE BEGIN
            count = count + 1  
         ENDELSE
      ENDIF
   ENDWHILE  
   FREE_LUN, unit  
   RETURN, count  
END


FUNCTION PSM_NLINECODE, nocomment=nocomment

  nnn = 0L

  ;; IDL programs
  ;;--------------
  pros = ALL_PSM_PROGRAMS()
  nel = N_ELEMENTS(pros)
  FOR i=0L, nel-1 DO nnn = nnn + COUNT_LINES_OF_CODE(pros[i], nocomment=nocomment)

  ;; F90 programs
  ;;--------------
  psmdir = GETPSMDIR('psmsoft')
  f90s = FILE_SEARCH(psmdir,'*.f90')
  nel = N_ELEMENTS(f90s)
  FOR i=0L, nel-1 DO nnn = nnn + COUNT_LINES_OF_CODE(f90s[i], nocomment=nocomment, code='f90')

  ;; C programs
  ;;------------
  psmdir = GETPSMDIR('psmsoft')
  cs = FILE_SEARCH(psmdir,'*.c')
  nel = N_ELEMENTS(cs)
  FOR i=0L, nel-1 DO nnn = nnn + COUNT_LINES_OF_CODE(cs[i], nocomment=nocomment, code='c')

  RETURN, nnn

END
