; This procedure is called in CREATE_SZ_SIMULATION in order to link
; the box pixel to its coordinates

PRO BOX_PIX2COORD, px, py, pz, x, y, z, dimensions, cell_size, map_type=map_type, reverse=reverse

IF KEYWORD_SET(reverse) EQ 0 THEN BEGIN
  IF STRLOWCASE(map_type) EQ 'small-map' THEN BEGIN
    x = (px+0.5)*cell_size
    z = ((pz+0.5)-dimensions[2]/2.)*cell_size
    y = ((py+0.5)-dimensions[1]/2.)*cell_size
  ENDIF
  IF STRLOWCASE(map_type) EQ 'all-sky' THEN BEGIN
    z = ((pz+0.5)-dimensions[2]/2.)*cell_size
    x = ((px+0.5)-dimensions[0]/2.)*cell_size
    y = ((py+0.5)-dimensions[1]/2.)*cell_size
  ENDIF
  IF STRLOWCASE(map_type) EQ 'half-sky' THEN BEGIN
    z = (pz+0.5)*cell_size
    x = ((px+0.5)-dimensions[0]/2.)*cell_size
    y = ((py+0.5)-dimensions[1]/2.)*cell_size
  ENDIF
ENDIF ELSE BEGIN
  IF STRLOWCASE(map_type) EQ 'small-map' THEN BEGIN
    py = FIX(y/cell_size+dimensions[1]/2.)
    pz = FIX(z/cell_size+dimensions[2]/2.)
    px = FIX(x/cell_size)
  ENDIF
  IF STRLOWCASE(map_type) EQ 'all-sky' THEN BEGIN
    py = FIX(y/cell_size+dimensions[1]/2.)
    pz = FIX(z/cell_size+dimensions[2]/2.)
    px = FIX(x/cell_size+dimensions[0]/2.)
  ENDIF
  IF STRLOWCASE(map_type) EQ 'half-sky' THEN BEGIN
    py = FIX(y/cell_size+dimensions[1]/2.)
    px = FIX(x/cell_size+dimensions[0]/2.)
    pz = FIX(z/cell_size)
  ENDIF
ENDELSE
END
