; Same function as COSMO_PK but with Efstathiou power spectrum.
; cluster keyword added, JBM, Feb 6 2006

;-----------------------------------------------------------------------
FUNCTION N_COSMO_PK_I_SIGMA, x
;---------------------------

COMMON N_COSMO_PK_NORM_PK_COSMO, n_norm_pk_cosmo, n_norm_pk_cluster
COMMON N_COSMO_PK_NORM_PK_SCALE, n_norm_pk_r

k = x/n_norm_pk_r

;gamma = n_norm_pk_cosmo.gamma
gamma = n_norm_pk_cluster.gamma
q = k/gamma/n_norm_pk_cosmo.h

;************ WARNING, THIS FUNCTION COPIED FROM MAIN ************
;*************** change BOTH if changes are needed ****************

Pk  =  k/(1.+((6.4*q)+(3.0*q)^(3./2)+(1.7*q)^2.)^(1.13))^(2/1.13)

IF (x LT 0.001) THEN Wk = 1. ELSE Wk  = 3./x^2*(sin(x)/x - cos(x))  

RETURN, k^2*Pk*Wk^2
END
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
FUNCTION N_COSMO_PK_NORM_PK, cosmo=cosmo, cluster=cluster
;--------------------------------------------------------

x1 = 0.0                       ; roots of Wth(x)
x2 = 4.496
x3 = 7.723
x4 = 10.902
x5 = 14.066
x6 = 17.221
x7 = 20.371

COMMON N_COSMO_PK_NORM_PK_COSMO, n_norm_pk_cosmo, n_norm_pk_cluster
COMMON N_COSMO_PK_NORM_PK_SCALE, n_norm_pk_r
n_norm_pk_cosmo = cosmo
n_norm_pk_cluster = cluster


; Normalization to sig8

n_norm_pk_r = 8./n_norm_pk_cosmo.h
sig1 = qromo('N_COSMO_PK_I_SIGMA',x1,x2)
sig2 = qromo('N_COSMO_PK_I_SIGMA',x2,x3)
sig3 = qromo('N_COSMO_PK_I_SIGMA',x3,x4)
sig4 = qromo('N_COSMO_PK_I_SIGMA',x4,x5)
sig5 = qromo('N_COSMO_PK_I_SIGMA',x5,x6)
if (sig5/sig1 gt 0.01) then stop, 'sig not converging'

RETURN,1./(2.*!pi^2)*(1./n_norm_pk_r)*(sig1+sig2+sig3+sig4+sig5)
END
;------------------------------------------------------------------------------

FUNCTION EFSPK, k, cosmo=cosmo, cluster=cluster, nonorm=nonorm

IF ( N_PARAMS() EQ 0 ) THEN BEGIN
	PRINT,'  CALL IS : pk = COSMO_PK(k)'
	PRINT,'  Keywords : cosmo=cosmo, cluster=cluster, nonorm=nonorm'
     GOTO, closing
ENDIF

;q = k/cosmo.omega_m/(cosmo.h)^2
;gamma = cosmo.gamma
gamma = cluster.gamma
q = k/gamma/cosmo.h
;bias = 1./(cosmo.sigma_8)
bias = 1./(cluster.sigma_8)
;************ WARNING, THIS FUNCTION COPIED IN I_SIGMA ************
;*************** change BOTH if changes are needed ****************

Pk  =  k/(1.+((6.4*q)+(3.0*q)^(3./2)+(1.7*q)^2.)^(1.13))^(2/1.13)

IF NOT KEYWORD_SET(nonorm) THEN BEGIN
	normpk = N_COSMO_PK_NORM_PK(cosmo=cosmo,cluster=cluster) 
	RETURN, Pk/normpk*(1./bias^2.)
ENDIF ELSE BEGIN
	RETURN, Pk
ENDELSE

closing:
END
