function kfactor, alpha, temp

;Taken from Schlegel routine predict_thermal.pro
;JPB: The values below for Kfitindx=2 are the same as those
;in Tab. 4 at 100 micron of Schlegel et al. 98 ApJ 500, 525
;Therefore, I assume that Kfactor=Dirbe/Model, as given in their Eq. 12

   ; We tabulate the K-factor for only the following emissivity profiles
   Kfitindx = [1.50, 1.67, 1.70, 2.00, 2.20, 2.60, 2.70]
   ia = (where(alpha EQ Kfitindx))[0]

   KfitAarr = $
    [ [  1.00000,  2.08243, -4.72422,  2.29118 ], $
      [  1.00000,  2.15146, -4.84539,  2.35210 ], $
      [  1.00000,  2.14106, -4.83639,  2.35919 ], $
      [  1.00000,  2.18053, -4.89849,  2.38060 ], $
      [  1.00000,  2.55941, -5.41290,  2.57867 ], $
      [  1.00000,  3.16383, -6.23131,  2.86900 ], $
      [  1.00000,  3.31600, -6.43306,  2.93939 ] ]

   KfitBarr = $
    [ [ -0.88339,  4.10104, -4.43324,  1.76240 ], $
      [ -0.87985,  4.10909, -4.43404,  1.76591 ], $
      [ -0.93625,  4.19278, -4.46069,  1.77103 ], $
      [ -0.80409,  3.95436, -4.27972,  1.70919 ], $
      [ -0.80318,  4.20361, -4.55598,  1.80207 ], $
      [ -0.50356,  4.07226, -4.70080,  1.87416 ], $
      [ -0.41568,  4.02002, -4.72432,  1.88865 ] ]
   nord = (size(KfitAarr))[1] - 1

; "temporary" function is used for better memory management
   log10T = alog10(temp)
   polya = KfitAarr[nord, ia]
   polyb = KfitBarr[nord, ia]
   for k=1, nord do begin
       polya = temporary(polya)*log10T + KfitAarr[nord-k, ia]
       polyb = temporary(polyb)*log10T + KfitBarr[nord-k, ia]
   endfor
log10T = 0 ; clear memory
   Kvalue = temporary(polya)/temporary(polyb)

   return, Kvalue
end
