; -----------------------------------------------------------------------------
;
; Copyright (C) 2011, 2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	GAL_COMP_LIST
;
; PURPOSE:
;	This function returns the list of valid PSM galactic component
;	names.
;
; CATEGORY:
;	Sky model
;
; CALLING SEQUENCE:
;	result = GAL_COMP_LIST()
;
; INPUTS:
;	None
;
; KEYWORD PARAMETERS:
;	None
;
; OUTPUTS:
;	a string array with the name of all valid PSM galactic
;	component names.
;
; RESTRICTIONS:
;       Report any bugs to Jacques Delabrouille
;       delabrouille@apc.univ-paris7.fr
;
; MODIFICATION HISTORY:
; 	13/05/2011:	Jacques Delabrouille, First version.
; 	06/01/2012:	JD, doc and PSM license header.
;-
FUNCTION GAL_COMP_LIST

  RETURN, ['synchrotron','freefree','thermaldust','spindust','co']

END
