; -----------------------------------------------------------------------------
;
; Copyright (C) 2010
;   Jacques Delabrouille
;   Guillaume Castex
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
;-
FUNCTION EXTRACT_SOURCE, cat, n


  creation_string = "source = {name:(*cat.objectname)[n],lon:(*cat.lon.value)[n],lat:(*cat.lat.value)[n]"

  CASE STRLOWCASE(cat.type) OF
     'comp': BEGIN
        FOR i=1, cat.nlaw DO BEGIN
           ok = EXECUTE('em = cat.e'+NUMBER2STRING(i))
           tags = EMLAW_PARAMLIST(em.law,/include_nurange,/include_ampl)
           ntags = N_ELEMENTS(tags)
           emstring = "e"+NUMBER2STRING(i)
           ok = EXECUTE(emstring+"=EMLAW_PARAMSTRUCT('"+em.law+"',/include_nurange,/include_ampl)")
           str1 = "ndimtags = SIZE(*cat.e"+NUMBER2STRING(i)+"."
           IF cat.polarised THEN IF cat.polar_model EQ 'GLOBAL' THEN MESSAGE, 'Case not implemented''
           FOR t=0, ntags-1 DO BEGIN
              ok = EXECUTE(str1 + tags[t] + ".value,/n_dimensions)")
              ei = emstring+'.'+tags[t]
              IF ndimtags EQ 0 THEN ok = EXECUTE('*'+ei+".value="+'(*cat.'+ei+ '.value)') ELSE BEGIN
                 IF ndimtags EQ 1 THEN ok = EXECUTE('*'+ei+".value="+'(*cat.'+ei+ '.value)[n]')
                 IF ndimtags EQ 2 THEN ok = EXECUTE('*'+ei+".value="+'(*cat.'+ei+ '.value)[n,*]')
              ENDELSE
              ok = EXECUTE(ei+".unit="+'(cat.'+ei+ '.unit)')
              ok = EXECUTE(ei+".info="+'(cat.'+ei+ '.info)')
           ENDFOR
           creation_string = creation_string+','+emstring+':'+emstring
        ENDFOR
        creation_string = creation_string+'}'
        ok = EXECUTE(creation_string)
     END
     'obs': BEGIN
        FOR i=1, cat.nobs DO BEGIN
        ENDFOR
        creation_string = creation_string + '}'
     END
  ENDCASE

  ok = EXECUTE(creation_string)
  
  RETURN, source

END
