; -----------------------------------------------------------------------------
;
; Copyright (C) 2010
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	PTRS
;
; PURPOSE:
;	...
;
;-
PRO PTRS, help=help

  r = PTR_VALID(count=nel)
  
  IF nel GE 1 THEN BEGIN
     IF NEL GT 1 THEN PSM_INFO_MESSAGE, NUMBER2STRING(nel)+' VALID POINTERS :' $
     ELSE PSM_INFO_MESSAGE, NUMBER2STRING(nel)+' VALID POINTER :'
     n = 10<nel
     h = STRARR(n)
     pt = STRARR(n)
     FOR i=0, n-1 DO BEGIN
        HELP, *r[i],  output=helpoutput
        truc = helpoutput[0]
        IF N_ELEMENTS(helpoutput) EQ 2 THEN truc = truc+helpoutput[1]
        machin = STRSPLIT(truc, ' ', /extract)
        a = PSM_STRING_TO_LENGTH(machin[0], 24)
        b = STRTRIM(PSM_STR_REPLACE(truc,machin[0],'' ),2)
        PSM_INFO_MESSAGE, a+b
     ENDFOR
     IF nel GT n THEN PSM_INFO_MESSAGE, '...'
  ENDIF ELSE BEGIN
     PSM_INFO_MESSAGE, 'NO VALID POINTER'
  ENDELSE

END
