; -----------------------------------------------------------------------------
;
; Copyright (C) 2010, 2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	LOWER_POWEROF2
;
; PURPOSE:
;	...
;
;-
FUNCTION LOWER_POWEROF2, number

  IF number LE 0 THEN MESSAGE, 'No power of 2 lower than number'
  IF number LT 1 THEN BEGIN
     
     n=1./number 
     cont=1
     val=1L
     WHILE cont DO BEGIN
        IF val GE n THEN cont=0
        val = val*2L
     END
     RETURN, 2./(val) 
     
  ENDIF ELSE BEGIN
     
     n=number       
     cont=1
     val=1L       
     WHILE cont DO BEGIN
        val = val*2L
        IF val GT n THEN cont=0
     END
     RETURN, val/2L 
     
  ENDELSE
  
END 
