FUNCTION RANDOM_DISTRIBUTION, proba, npoint, iseed=iseed, silent=silent, double=double
  t0 = SYSTIME(1)

  outarr=proba*0.
 
  tot = TOTAL(proba)
  IF (tot NE 1) THEN BEGIN
     IF NOT KEYWORD_SET(silent) THEN BEGIN
        PRINT, '  WARNING, INTEGRATED PROBABILITY DIFFERENT FROM 1'
        PRINT, '  RENORMALIZING...'
     ENDIF
     proba = proba/tot
     tot = TOTAL(proba)
  ENDIF


  nel=N_ELEMENTS(outarr)
  FOR i=0L, nel-1 DO BEGIN
    IF proba[i] gt 0 THEN outarr[i] = randomn(iseed, poisson=npoint*proba[i], double=double)
  ENDFOR
  IF NOT KEYWORD_SET(silent) THEN PRINT,'TOTAL RAND_DIST  time=', round(systime(1)-t0), ' sec'

return, outarr
closing:
END
