; -----------------------------------------------------------------------------
;
; Copyright (C) 2011
;   Guillaume Castex
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	PRINT_PIX_SOURCE
;
; PURPOSE:
;	...
;
;-
PRO PRINT_PIX_SOURCES, nside, map, lat, lon, ordering=ordering, radius=radius

  IF NOT KEYWORD_SET(radius) THEN radius=1
  IF NOT KEYWORD_SET(ordering) THEN ordering='RING'
 
  ang2vec,!dpi/2-lat, lon, vector
  
  
  FOR i=0L,n_elements(vector[*,0])-1 DO BEGIN
  
     IF ordering eq 'NESTED' THEN query_disc, nside, vector[i,*], radius, listpix, /deg, /nested ELSE query_disc, nside, vector[i,*], radius, listpix, /deg
     (*map)[listpix]= (*map)[listpix]+1./n_elements(listpix)
     
  ENDFOR
  

END
